/* CDLL: circular doubly-linked list.
   in TBCppA project: tracer-based CPP analyzer.
    Copyright (c) 2006 Katsuhiko Gondow (gondow(at)cs.titech.ac.jp)
    $Id: list.h,v 1.3 2006/10/25 02:15:55 gondow Exp gondow $ */
#ifndef TBCPPA_LIST_H
#define TBCPPA_LIST_H
#include <stdio.h>
/* ---------------------------------------------------------------------- */
struct CDLL {
    char *param_name; /* assumes dynamically allocated */
    struct CDLL *next, *prev;
};
/* ---------------------------------------------------------------------- */
void CDLL_init    (struct CDLL *head);
void CDLL_insert  (struct CDLL *head, char *param_name);
struct CDLL *CDLL_append  (struct CDLL *list1, struct CDLL *list2);
int  CDLL_query   (struct CDLL *head, char *param_name);
#if 0
struct CDLL *CDLL_tpop  (struct CDLL *head);
#endif
void CDLL_free    (struct CDLL *head);
int  CDLL_is_null (struct CDLL *head);
void CDLL_dump    (struct CDLL *head) __attribute__ ((unused));
/* ---------------------------------------------------------------------- */
#endif /* TBCPPA_LIST_H */
