#!/bin/csh -f

#  tifexp.csh: translator from if-expression to clickable HTML.
#  in TBCppA project: tracer-based CPP analyzer.
#  Copyright (c) 2006   Katsuhiko Gondow (gondow(at)cs.titech.ac.jp)
#  $Id: tifexp.csh,v 1.2 2006/10/18 11:14:24 gondow Exp gondow $

# Usage: tifexp.csh foo.c.xml 100

mkdir -p HTML

set TBCPPA_BINDIR = ~/paper/fose06/src2
set XML_FILE      = $1
set LINE_NUMBER   = $2
set FILENAME      = $3
set DOT_FILE      = HTML/$1:r.i.dot
set MAIN_HTML     = HTML/$1:r.i.main.html
set GRAPH_HTML    = HTML/$1:r.i.graph.html
set GIF_FILE      = HTML/$1:r.i.gif
set CMAP_FILE     = HTML/$1:r.i.cmap
set SVG_FILE      = HTML/$1:r.i.svg
set EPS_FILE      = HTML/$1:r.i.eps

# append $TBCPPA_DIR if not in path
echo $path | grep -q $TBCPPA_BINDIR
if ( $status ) then
  set path=($TBCPPA_BINDIR $path:q)
endif

xsltproc --stringparam line "$LINE_NUMBER"  \
         --stringparam filename "$FILENAME" \
         $TBCPPA_BINDIR/tifexp.xsl $1 > $DOT_FILE

dot -Tgif  $DOT_FILE > $GIF_FILE
dot -Tcmap $DOT_FILE > $CMAP_FILE
dot -Tsvg  $DOT_FILE > $SVG_FILE
dot -Tps   $DOT_FILE > $EPS_FILE

cat > $MAIN_HTML <<EOF
<html>
<frameset cols="60%, *">
    <frame src="$GRAPH_HTML:t" name="gif">
    <frame src="" name="src">
</frameset>
</html>
EOF

cat > $GRAPH_HTML <<EOF
<html><body>
<img src="$GIF_FILE:t" alt="$GIF_FILE:t" usemap="#map"/>
<map name="map">
EOF

cat >> $GRAPH_HTML < $CMAP_FILE

cat >> $GRAPH_HTML <<EOF
</map></body></html>
EOF

ed $GRAPH_HTML >& /dev/null <<EOF
1,\$s/^<area/<area target="src"/g
w
q
EOF

cygstart $MAIN_HTML
#end
