#!/bin/csh -f

#  tmacro.csh: translator from macro expansion to clickable HTML.
#  in TBCppA project: tracer-based CPP analyzer.
#  Copyright (c) 2006   Katsuhiko Gondow (gondow(at)cs.titech.ac.jp)
#  $Id: tmacro.csh,v 1.2 2006/06/08 17:33:49 gondow Exp $

# Usage: tmacro.csh foo.c.xml FOO [100]

mkdir -p HTML

set TBCPPA_BINDIR = ~/paper/fose06/src2
set XML_FILE      = $1
set MACRO_NAME    = $2
set LINE_NUMBER   = $3
set DOT_FILE      = HTML/$1:r.m.dot
set MAIN_HTML     = HTML/$1:r.m.main.html
set GRAPH_HTML    = HTML/$1:r.m.graph.html
set GIF_FILE      = HTML/$1:r.m.gif
set CMAP_FILE     = HTML/$1:r.m.cmap
set SVG_FILE      = HTML/$1:r.m.svg
set EPS_FILE      = HTML/$1:r.m.eps

# append $TBCPPA_DIR if not in path
echo $path | grep -q $TBCPPA_BINDIR
if ( $status ) then
  set path=($TBCPPA_BINDIR $path:q)
endif

xsltproc --stringparam macro $MACRO_NAME --stringparam line "$LINE_NUMBER" $TBCPPA_BINDIR/tmacro.xsl $1 > $DOT_FILE

dot -Tgif  $DOT_FILE > $GIF_FILE
dot -Tcmap $DOT_FILE > $CMAP_FILE
dot -Tsvg  $DOT_FILE > $SVG_FILE
dot -Tps   $DOT_FILE > $EPS_FILE

cat > $MAIN_HTML <<EOF
<html>
<frameset cols="60%, *">
    <frame src="$GRAPH_HTML:t" name="gif">
    <frame src="" name="src">
</frameset>
</html>
EOF

cat > $GRAPH_HTML <<EOF
<html><body>
<img src="$GIF_FILE:t" alt="$GIF_FILE:t" usemap="#map"/>
<map name="map">
EOF

cat >> $GRAPH_HTML < $CMAP_FILE

cat >> $GRAPH_HTML <<EOF
</map></body></html>
EOF

ed $GRAPH_HTML >& /dev/null <<EOF
1,\$s/^<area/<area target="src"/g
w
q
EOF

cygstart $MAIN_HTML
#end
